from collections import OrderedDict
import ConfigParser
from StringIO import StringIO
import os
import sys
from jinja2 import Environment, FileSystemLoader

aBigDict = {}

class MultiOrderedDict(OrderedDict):
	def __setitem__(self, key, value):
		if isinstance(value, list) and key in self:
			self[key].extend(value)
		else:
			super(OrderedDict, self).__setitem__(key, value)

parser = ConfigParser.RawConfigParser(dict_type=MultiOrderedDict)
file_loc = os.path.abspath(".")+'/pally/'+str(sys.argv[1])

with open(file_loc) as stream:
	stream = StringIO("[top]\n" + stream.read())
	parser.readfp(stream)

calmesh = parser.get('top','mesh')
calskel = parser.get('top','skeleton')
calanim = parser.get('top','animation')

env = Environment(loader=FileSystemLoader('.'))

meshList = []
inti = 0
for mesh in calmesh:
	meshDict = {}
	meshDict['file'] = str(mesh)
	meshDict['name'] = 'meshpoo'+str(inti)
	meshList.append(meshDict)
	inti+=1

aniList = []
inti = 0
for ani in calanim:
	aniDict = {}
	aniDict['file'] = str(ani)
	aniDict['name'] = 'strut'
	aniList.append(aniDict)
	inti+=1

skelList = []
for skele in calskel:
	skelDict = {}
	skelDict['file'] = str(skele)
	skelList.append(skelDict)

aBigDict['animations'] = aniList
aBigDict['skeletons'] = skelList
aBigDict['meshes'] = meshList

print(aBigDict)

template = env.get_template('testcal3d.cal3d.j2')
output = template.render(aBigDict)

with open("test.cal3d","wb") as fh:
	fh.write(output)
